// matrix.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "windows.h"
#include "shlwapi.h" //StrToInt()
#include "malloc.h"

#define FILENAME "d:\\m1.txt"

int main(int argc, char* argv[])
{
	HANDLE hFile = CreateFile(FILENAME, GENERIC_READ,
			FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING,
            FILE_ATTRIBUTE_NORMAL, NULL);
	if (hFile == INVALID_HANDLE_VALUE)
		return 1;
	HANDLE hFileMap = CreateFileMapping(hFile, NULL, PAGE_READONLY, 0, 0, NULL);
	char *fmatr = (char *) MapViewOfFile(hFileMap, FILE_MAP_READ, 0, 0, 0);;

	int **matrica;
	unsigned i, n = 1;
	for (i = 0; i < strlen(fmatr); i++) {
		if (fmatr[i] == ' ')
			n++;
		if (fmatr[i] == '\r')
			break;
	}
	matrica = (int **) calloc(n, sizeof(int*));
	for (i = 0; i < n; i++)
		matrica[i] = (int *) calloc(n, sizeof(int));
	
	int j = 0, a = 0, n1 = 0, n2 = 0;
	char val[3] = "";
	for (i = 0; i < strlen(fmatr); i++) {
		if (fmatr[i] == '\r') {
			matrica[n1++][n2] = StrToInt(val);
			n2 = 0;
			i++;
			j++;
			a = 0;
			strcpy(val, "");
			continue;
		}
		if (fmatr[i] != ' ') 
			val[a++] = fmatr[i];
		else {
			matrica[n1][n2++] = StrToInt(val);
			a = 0;
			strcpy(val, "");
		}
	}
	matrica[n1][n2] = StrToInt(val);

	for (i = 0; i < n; i++) 
		free(matrica[i]);
	free(matrica);
	UnmapViewOfFile(fmatr);
	CloseHandle(hFileMap);
	CloseHandle(hFile);
	return 0;
}
